> For the complete documentation index, see [llms.txt](https://docs.stackai.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stackai.com/workflow-builder/utils-logic-and-others/logic/loop-subflow.md).

# Loop Subflow

{% @arcade/embed flowId="mhXFVGpx8Bi2MMBxhSDV" url="<https://app.arcade.software/share/mhXFVGpx8Bi2MMBxhSDV>" %}

The Loop Subflow Node allows you to run a branch of your project in a loop over a list of inputs. To set up the node, make sure you are inputting a list of any form.

This node provides two execution branches:

* **Loop**\
  This branch runs once for each item in the input list. During each iteration, the current item is available via the `current_item` variable. **Important:** If you want to collect results across all iterations, you must attach an output node at the end of the Loop branch. Only outputs explicitly emitted there will be aggregated.
* **Done**\
  This branch executes after all items have been processed by the Loop branch. If outputs were emitted during the Loop branch, they will be aggregated and made available here.

### **Common Pitfalls**

* **List passed as a string**\
  If the entire list appears inside `current_item` instead of a single element, the input may have been parsed as a string rather than a list.

  **Example:**

  * Incorrect: `"[item_1, item_2, item_3]"` (string)
  * Correct: `[item_1, item_2, item_3]` (list)

  Ensure the input is a properly structured list so each item is processed individually.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stackai.com/workflow-builder/utils-logic-and-others/logic/loop-subflow.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
